// ---------------------------------------------------------------------------------
//
// embox v1.0
// by jslee@embian.com - http://efolder.tistory.com 
// 2007.07.03
// 
// Licensed under the Creative Commons Attribution-ShareAlike 2.0 Korea - http://creativecommons.org/licenses/by-sa/2.0/kr/
//
// ---------------------------------------------------------------------------------


/*------ kind of options -----------*/
/* url='http://efolder.tistory.com'	*/
/* btnValue='This Button'			*/
/* width='400'						*/
/* height='200'						*/
/*------ kind of options -----------*/

// - syntax -
// new embox(msg, {options});
//
// - example -
// var objBox = new embox('hi there~!!', {url:"http://efolder.tistory.com", btnValue:"Go Go", width:'400', height:'200'});
// objBox.showBox();
//

var embox = Class.create();
embox.prototype = {

	initialize: function(msg, options) {
		this.initBox();
		
		if( !msg ) this.message = "default";
		else this.message = msg;
		this.w = '250';	
		this.h = '110';	
		if( options ){

			if( !options.url ) this.url = null;
			else this.url = options.url;

			if( !options.btnValue ) this.btnValue = null;
			else this.btnValue = options.btnValue;

			if( !options.width ) this.w='250';
			else this.w = options.width;

			if( !options.height) this.h='110';
			else this.h = options.height;
		}	

		this.divCheck();
	},

	initBox: function() {
		// <body>
		// ...
		// <div id='backlayer'></div>
		// <div id='alert_Window'></div>
		// <div id='alert_load'></div>
		// </body>
		var obj = $('backlayer')	
		var obj1 = $('alert_Window')	
		var obj2 = $('alert_load')	

		var objBody = document.getElementsByTagName("body").item(0);
		if( !obj){
			var objDiv = document.createElement('DIV');
			objDiv.setAttribute('id', 'backlayer');
			objBody.appendChild(objDiv);
		}

		if( !obj1 ){
			objDiv = document.createElement('DIV');
			objDiv.setAttribute('id', 'alert_Window');
			objBody.appendChild(objDiv);
		}

		if( !obj2 ){
			objDiv = document.createElement('DIV');
			objDiv.setAttribute('id', 'alert_load');
			objBody.appendChild(objDiv);
		}
	},

	setMessage: function(msg) {
		this.message = msg;
	},	

	drawOverlay: function () {
		var elm = $('backlayer');
		var size = embianCommon.browserSize();
		elm.style.position = "absolute";
		elm.style.left = elm.style.top = 0;
		elm.style.width = size[0] + "px";
		elm.style.height = size[1] + "px";
		elm.style.display ='block';
	},

	sizeBox: function() {
		var size =  embianCommon.browserSize2();
		var div1 = $('alert_Window');
		div1.style.position = "absolute";
		div1.style.bottom=(size[1]/2)-(this.h/2) + 'px';
		div1.style.left=(size[0]/2)-(this.w/2) + 'px';
	},

	imgsizeBox: function() {
		var div1=document.getElementById('alert_Window');
		div1.style.position = "absolute";
		div1.style.top='10px';
		div1.style.left='10px';
	},

	callBox: function() {
		this.drawOverlay();
		this.sizeBox();
	},

	imgcallBox: function() {
		this.drawOverlay();
		this.imgsizeBox();
	},

	divCheck: function() {
		var strW = this.w;
		var strH = this.h;
		
		window.onresize = function(){
			var chk = $('alert_content');
			if (chk!=null) {
				var elm = $('backlayer');
				var size = embianCommon.browserSize();
				elm.style.position = "absolute";
				elm.style.left = elm.style.top = 0;
				elm.style.width = size[0] + "px";
				elm.style.height = size[1] + "px";
				elm.style.display ='block';

				var size =  embianCommon.browserSize2();
				var div1 = $('alert_Window');
				div1.style.position = "absolute";
				div1.style.bottom=(size[1]/2)-(strH/2) + 'px';
				div1.style.left=(size[0]/2)-(strW/2) + 'px';

			}
		}
	},	

	closeBox: function() {
		var div1=$('alert_Window');
		var div2=$('backlayer');
		div1.innerHTML = "";
		div1.style.display='none';
		div2.style.display='none';
	},

	readyBox: function() {
		var div1=$('alert_Window');
		div1.style.display='block';
		var div2=document.createElement('DIV');
		div2.setAttribute('id','alert_content');
//		div2.className = 'alert_loading';
		div1.appendChild(div2);
		div2.innerHTML = this.message;
		$('alert_content').focus();
		$('alert_content').blur();

		if(this.btnValue) {
			div2.className = '';
			var div3=document.createElement('DIV');
			div3.setAttribute('id','alert_button');
			div1.appendChild(div3);
			var input1=document.createElement('INPUT');
			input1.setAttribute('type','button');
			input1.setAttribute('value',this.btnValue);
			var strURL = this.url;
			input1.onclick = function() {
				if( !strURL ){
					var div1=$('alert_Window');
					div1.innerHTML = "";
					div1.style.display='none';
					$('backlayer').style.display='none';
				}else {
					window.location.href=strURL;
				}
				return true;
				
			}
			input1.setAttribute('id','alert_btn');
			input1.className='inputsubmit';
			div3.appendChild(input1);
			$('alert_btn').focus();
		}else{
			div1.onclick = function() {
				div1.innerHTML = "";
				div1.style.display='none';
				$('backlayer').style.display='none';
				return true;
			}
		}
	},

	setBoxStyle: function() {
		var strW = this.w+'px';
		var strH = this.h+'px';
		$('alert_Window').setStyle({
			'width':strW,
			'height':strH
		});
	},

	lightBox: function() {
		this.callBox();
		this.readyBox();
		this.setBoxStyle();
	},

	showBox: function() {
		this.lightBox();
	}

}

/*---------------- Common Function ---------------*/
var embianCommon = {
	browserSize: function() {
		var x = window.innerWidth ||
			document.documentElement.clientWidth ||
			document.body.clientWidth ||
			0;
		var y = window.innerHeight ||
			document.documentElement.clientHeight ||
			document.body.clientHeight ||
			0;

		var x2 = document.body.scrollWidth;
		var y2 = document.body.scrollHeight;
		if (x2 > x) { x = x2; }
		if (y2 > y) { y = y2; }

		return [x, y];
	},

	browserSize2: function() {
		var x = window.innerWidth ||
			document.documentElement.clientWidth ||
			document.body.clientWidth ||
			0;
		var y = window.innerHeight ||
			document.documentElement.clientHeight ||
			document.body.clientHeight ||
			0;

		return [x, y];
	}
}
/*------------------------------------------------*/
